adminadopet/urls.py
from django.urls import path
from . import views

app_name = 'adminadopet'

urlpatterns = [
    path('', views.beranda, name='beranda'),
    path('eval-open-donasi/<id>/delete', views.delete_open_donasi, name= 'delete_open_donasi'),
    path('eval-open-donasi/<id>/', views.eval_open_donasi, name='eval_open_donasi'),
    path('eval-artikel/<id>/', views.eval_artikel, name='eval_artikel'),
    path('eval-artikel/<id>/delete', views.delete_artikel, name='delete_artikel'),
    path('berhasil-unggah/', views.berhasil_unggah, name="berhasil_unggah"),
    path('search/', views.search, name='search'),
]

adopet/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('user/', include('user.urls')),
    path('admin-adopet/', include('adminadopet.urls')),
]

user/urls.py
from django.urls import path
from . import views

app_name = 'user'

urlpatterns = [
    path('form-request-open-donasi/', views.form_request_open_donasi, name='form_request_open_donasi'),
    path('detail-donasi/<id>/', views.detail_donasi, name='detail_donasi'),
    path('detail-donasi/<id>/melakukan-donasi/', views.melakukan_donasi, name='melakukan_donasi'),
    path('detail-donasi/<id>/list-donasi/', views.list_donasi, name='list_donasi'),
    path('detail-donasi/<id_donasi>/list-donasi/<id_pendonasian>/delete', views.delete_pendonasian, name='delete_pendonasian'),
    path('detail-donasi/<id_donasi>/list-donasi/<id_pendonasian>/berhasil', views.berhasil_donasi, name='berhasil_donasi'),
    path('form-open-adopt/', views.form_open_adopt, name='form_open_adopt'),
    path('detail-open-adopt/<id>/', views.detail_open_adopt, name='detail_open_adopt'),
    path('detail-open-adopt/<id>/buat-forum/', views.buat_forum, name='buat_forum'),
    path('detail-open-adopt/<id_hewan>/forum/<id_forum>/reply/', views.reply_forum, name='reply_forum'),
    path('detail-open-adopt/<id>/form-pengadopsian/', views.form_pengadopsian, name='form_pengadopsian'),
    path('detail-open-adopt/<id>/detail-pengadopsian/', views.detail_pengadopsian, name='detail_pengadopsian'),
    path('detail-open-adopt/<id_hewan>/detail-pengadopsian/<id_adopsi>/delete', views.delete_request_adopsi, name='delete_request_adopsi'),
    path('detail-open-adopt/<id_hewan>/detail-pengadopsian/<id_adopsi>/berhasil', views.berhasil_adopsi, name='berhasil_adopsi'),
    path('profil/', views.profil, name='profil'),
    path('form-request-artikel/', views.form_request_artikel, name='form_request_artikel'),
    path('', views.beranda, name='beranda'),
    path('berhasil-unggah/', views.berhasil_unggah, name='berhasil_unggah'),
    path('berhasil-request/', views.berhasil_request, name='berhasil_request'),
    path('detail-artikel/<id>/', views.detail_artikel, name='detail_artikel'),
    path('profil/buat-testimoni/', views.buat_testimoni, name='buat_testimoni'),
    path('chatpage/', views.chatpage, name='chatpage'),
    path('chatpage/send/<id_pengirim>/<id_penerima>', views.send_message, name='send_message'),
    path('list_hewan/', views.list_hewan, name='list_hewan'),
    path('list_foto/', views.list_foto, name='list_foto'),
    path('search/', views.search, name='search')
]

user/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver


class Hewan(models.Model):
    KATEGORI_HEWAN = [
        ("Kucing", "Kucing"),
        ("Anjing", "Anjing"),
        ("Kelinci", "Kelinci"),
        ("Burung", "Burung"),
        ("Ikan", "Ikan"),
        ("Hewan Pengerat", "Pengerat"),
        ("Unggas", "Unggas"),
        ("Reptil", "Reptil"),
        ("Lainnya", "Lainnya")
    ]

    JENIS_KELAMIN_HEWAN = [
        ("Jantan", "Jantan"),
        ("Betina", "Betina")
    ]

    nama_hewan = models.CharField(max_length = 50)
    jenis_hewan = models.CharField(max_length = 50)
    jenis_kelamin_hewan = models.CharField(max_length = 50, choices = JENIS_KELAMIN_HEWAN)
    usia_hewan = models.CharField(max_length = 50)
    domisili_hewan = models.CharField(max_length = 50)
    keterangan = models.CharField(max_length = 500, default = "")
    kategori = models.CharField(max_length = 50, choices = KATEGORI_HEWAN)
    kondisi_fisik_hewan = models.CharField(max_length = 500)
    kondisi_psikis_hewan = models.CharField(max_length = 500)
    mahar_adopsi = models.CharField(max_length = 500, default = "")

class FotoHewan(models.Model):
    foto = models.ImageField(upload_to='static/images/')
    hewan = models.ForeignKey(Hewan, on_delete=models.CASCADE)

class RequestAdopsi(models.Model):
    id_hewan = models.CharField(max_length = 50)
    nama_hewan = models.CharField(max_length = 50)
    nama_pengadopsi = models.CharField(max_length = 50)
    nomor_hp = models.CharField(max_length = 14)
    email_pengadopsi = models.CharField(max_length = 50)
    alamat_pengadopsi = models.CharField(max_length = 200)

class Donasi(models.Model):
    KATEGORI_HEWAN = [
        ("Kucing", "Kucing"),
        ("Anjing", "Anjing"),
        ("Kelinci", "Kelinci"),
        ("Burung", "Burung"),
        ("Ikan", "Ikan"),
        ("Hewan Pengerat", "Pengerat"),
        ("Unggas", "Unggas"),
        ("Reptil", "Reptil"),
        ("Lainnya", "Lainnya")
    ]

    JENIS_KELAMIN_HEWAN = [
        ("Jantan", "Jantan"),
        ("Betina", "Betina")
    ]

    nama_hewan = models.CharField(max_length = 50)
    jenis_hewan = models.CharField(max_length = 50)
    jenis_kelamin_hewan = models.CharField(max_length = 50, choices = JENIS_KELAMIN_HEWAN)
    usia_hewan = models.CharField(max_length = 50)
    domisili_hewan = models.CharField(max_length = 50)
    keterangan = models.CharField(max_length = 500, default = "")
    kategori = models.CharField(max_length = 50, choices = KATEGORI_HEWAN)
    kondisi_kesehatan = models.CharField(max_length = 500)
    lokasi_perawatan = models.CharField(max_length = 100)
    biaya_perawatan = models.CharField(max_length = 50, default = "")
    verifikasi = models.BooleanField(default = False)

class Testimoni(models.Model):
    NILAI = [
        ("0", "0"),
        ("1", "1"),
        ("2", "2"),
        ("3", "3"),
        ("4", "4"),
        ("5", "5"),
    ]
    nama_user = models.CharField(max_length = 50, default="admin")
    nilai_user = models.CharField(max_length = 50, choices = NILAI)
    komentar_user = models.CharField(max_length = 400)

class Artikel(models.Model):
    TAG = [
        ("Anjing", "Anjing"),
        ("Artikel", "Artikel"),
        ("Kucing", "Kucing"),
        ("Makanan", "Makanan")
    ]
    judul_artikel = models.CharField(max_length = 50)
    isi_artikel = models.CharField(max_length = 500)
    tag_artikel = models.CharField(max_length = 50)
    verifikasi_artikel = models.BooleanField(default = False)

class Pendonasian(models.Model):
    METODE = [
        ("gopay", "Gopay"),
        ("jenius", "Jenius"),
        ("linkaja", "Linkaja"),
        ("ovo", "OVO"),
        ("bca", "BCA"),
        ("bni", "BNI"),
        ("bri", "BRI"),
        ("mandiri", "Mandiri"),
        ("visa", "Visa")
    ]

    id_donasi = models.CharField(max_length = 50, default = "")
    nominal_donasi = models.CharField(max_length = 50)
    metode_donasi = models.CharField(max_length = 50, choices = METODE)
    nama_pendonasi = models.CharField(max_length = 50)
    hp_email = models.CharField(max_length = 50)
    dukungan = models.CharField(max_length = 500)

class Forum(models.Model):
    id_adopt = models.CharField(max_length = 50, default ="")
    judul_forum = models.CharField(max_length = 50)
    isi_forum = models.CharField(max_length = 500)

class ReplyForum(models.Model):
    id_forum = models.CharField(max_length = 50, default ="")
    reply_forum = models.CharField(max_length = 500)

class HistoryChat(models.Model):
    pengirim = models.CharField(max_length = 500, default ="")
    penerima = models.CharField(max_length = 500, default ="")
    datetimep = models.DateTimeField(auto_now=True)
    pesan = models.CharField(max_length = 999)

templates/opendonasi/detail-open-donasi.html
{% extends 'navbar.html' %}
{% block content_block %}
{% load static %}
<head>
	<link rel="stylesheet" href="{% static 'css/openadopt.css' %}" type="text/CSS">
</head>
<a href="{% url 'user:beranda' %}" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Open Donasi untuk {{donasi.nama_hewan}}</p><br>
	</div>
</div>
<div class="container">
    <div class="row justify-content-center">
        <div class="col-7">
            <p class="form-label">Nama Hewan :</p>
            <p class="jawaban">{{donasi.nama_hewan}}</p>
            <p class="form-label">Jenis Hewan :</p>
            <p class="jawaban">{{donasi.jenis_hewan}}</p>
            <p class="form-label">Jenis Kelamin Hewan :</p>
            <p class="jawaban">{{donasi.jenis_kelamin_hewan}}</p>
            <p class="form-label">Usia Hewan :</p>
            <p class="jawaban">{{donasi.usia_hewan}}</p>
            <p class="form-label">Domisili Hewan :</p>
            <p class="jawaban">{{donasi.domisili_hewan}}</p>
            <p class="form-label">Keterangan :</p>
            <p class="jawaban">{{donasi.keterangan}}</p>
            <p class="form-label">Kategori :</p>
            <p class="jawaban">{{donasi.kategori}}</p>
            <p class="form-label">Kondisi Kesehatan Secara Detail :</p>
            <p class="jawaban">{{donasi.kondisi_kesehatan}}</p>
            <p class="form-label">Lokasi Perawatan/Pengobatan :</p>
            <p class="jawaban">{{donasi.lokasi_perawatan}}</p>
            <p class="form-label">Biaya Perawatan/Pengobatan :</p>
            <p class="jawaban">{{donasi.biaya_perawatan}}</p>
        </div>    
    </div>
    <div class="row justify-content-center unggah">
        <a type="button" class="btn btn-adopsi" style="margin-bottom: 10vh;" onclick="location.href='/user/detail-donasi/{{donasi.id}}/melakukan-donasi/'"> Mau Berdonasi </a> 
        <a type="button" class="btn btn-adopsi" style="margin-bottom: 10vh;" onclick="location.href='/user/detail-donasi/{{donasi.id}}/list-donasi/'">List Donasi</a>
    </div>
</div>
{% endblock content_block %}

templates/opendonasi/form-eval-open-donasi.html
{% extends 'head.html' %}
{% block content_block %}
<a href="{% url 'adminadopet:beranda' %}" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Request Open Donasi #{{donasi.id}}</p><br>
	</div>
</div>


{% load static %}
<div class="container">
    <div class="row justify-content-center">
        <div class="col-7">
            <p class="form-label">Nama Hewan :</p>
            <p class="jawaban">{{donasi.nama_hewan}}</p>
            <p class="form-label">Jenis Hewan :</p>
            <p class="jawaban">{{donasi.jenis_hewan}}</p>
            <p class="form-label">Jenis Kelamin Hewan :</p>
            <p class="jawaban">{{donasi.jenis_kelamin_hewan}}</p>
            <p class="form-label">Usia Hewan :</p>
            <p class="jawaban">{{donasi.usia_hewan}}</p>
            <p class="form-label">Domisili Hewan :</p>
            <p class="jawaban">{{donasi.domisili_hewan}}</p>
            <p class="form-label">Keterangan :</p>
            <p class="jawaban">{{donasi.keterangan}}</p>
            <p class="form-label">Kategori :</p>
            <p class="jawaban">{{donasi.kategori}}</p>
            <p class="form-label">Kondisi Kesehatan Secara Detail :</p>
            <p class="jawaban">{{donasi.kondisi_kesehatan}}</p>
            <p class="form-label">Lokasi Perawatan/Pengobatan :</p>
            <p class="jawaban">{{donasi.lokasi_perawatan}}</p>
            <p class="form-label">Biaya Perawatan/Pengobatan :</p>
            <p class="jawaban">{{donasi.biaya_perawatan}}</p>  
        </div>
    </div>
    <div class="row justify-content-around unggah">
        <form method ="POST" action="{% url 'adminadopet:delete_open_donasi' donasi.id %}">{% csrf_token %}
            <div class="col-6">
                <button type="submit" class="btn btn-eval Delete">Tolak</button>
            </div>     
        </form>
        <form method ="POST" action="{% url 'adminadopet:eval_open_donasi' donasi.id %}">{% csrf_token %}
            <div class="col-6">
                <button type="submit" class="btn btn-eval Unggah">Unggah</button>
            </div>     
        </form>  
    </div>
</div>

{% endblock content_block %}

templates/opendonasi/form-request-open-donasi.html
{% extends 'head.html' %}
{% block content_block %}
<a href="{% url 'user:beranda' %}" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Form Request Open Donasi</p><br>
	</div>
</div>
<form method="POST"> {% csrf_token %}
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-7">
                <label for="id_nama_hewan" class="form-label">Nama Hewan<span class="star">*</span> </label>
                <input type="text" id="id_nama_hewan" class="form-control" name="nama_hewan" required="">
                
                <label for="id_jenis_hewan" class="form-label">Jenis Hewan<span class="star">*</span> </label>
                <input type="text" id="id_jenis_hewan" class="form-control" name="jenis_hewan" required="">   
                
                <div class="form-group">
                    <label for="id_jenis_kelamin_hewan" class="form-label">Jenis Kelamin Hewan<span class="star">*</span> </label>
                    <select class="form-control" name="jenis_kelamin_hewan" required="" id="id_jenis_kelamin_hewan">
                        <option value="" selected="">Pilih Jenis Kelamin</option>
                        <option value="Jantan">Jantan</option>
                        <option value="Betina">Betina</option>
                    </select>
                </div>
    
                <label for="id_usia_hewan" class="form-label">Usia Hewan<span class="star">*</span> </label>
                <input type="text" id="id_usia_hewan" class="form-control" name="usia_hewan" required="">   
                
                <label for="id_domisili_hewan" class="form-label">Domisili Hewan<span class="star">*</span> </label>
                <input type="text" id="id_domisili_hewan" class="form-control" name="domisili_hewan" required="">   
                
                <label for="id_keterangan" class="form-label">Keterangan</label>
                <input type="text" id="id_keterangan" class="form-control form-big" name="keterangan">   
                
                <div class="form-group">
                    <label for="id_kategori" class="form-label">Kategori<span class="star">*</span> </label>
                    <select class="form-control" name="kategori" required="" id="id_kategori">
                        <option value="" selected="">Pilih Kategori</option>
                        <option value="Kucing">Kucing</option>
                        <option value="Anjing">Anjing</option>
                        <option value="Kelinci">Kelinci</option>
                        <option value="Burung">Burung</option>
                        <option value="Ikan">Ikan</option>
                        <option value="Pengerat">Hewan Pengerat</option>
                        <option value="Unggas">Unggas</option>
                        <option value="Reptil">Reptil</option>
                        <option value="Lainnya">Lainnya</option>
                    </select>
                </div>
                
                <label for="id_kondisi_kesehatan" class="form-label">Detail Kondisi Kesehatan Hewan<span class="star">*</span> </label>
                <input type="text" id="id_kondisi_kesehatan" class="form-control form-big" name="kondisi_kesehatan" required="">  
                
                <label for="id_lokasi_perawatan" class="form-label">Lokasi Perawatan/Pengobatan<span class="star">*</span> </label>
                <input type="text" id="id_lokasi_perawatan" class="form-control form-big" name="lokasi_perawatan" required="">  
                
                <label for="id_biaya_perawatan" class="form-label">Biaya Perawatan/Pengobatan<span class="star">*</span> </label>
                <input type="text" id="id_biaya_perawatan" class="form-control" name="biaya_perawatan" required="">  
            </div>
        </div>
        <div class="row justify-content-center unggah">
            <button type="submit" class="btn btn-secondary" style="margin-bottom: 10vh; margin-top: 15vh;">Request</button>
        </div>
    </div>
    </form>
{% endblock content_block %}

templates/opendonasi/list-donasi.html
{% extends 'navbar.html' %}
{% block content_block %}
{% load static %}
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="{% static 'css/openadopt.css' %}" type="text/CSS">
</head>
<a type="button" onclick="location.href='/user/detail-donasi/{{donasi.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
    <div class="row justify-content-center">
        <div class="list-donasi">
            <h2 class="judul-post-adopsi" style="padding-bottom: 3vh;">List Pendonasian</h2>
            {% for i in pendonasian %}
            {% if i.id_donasi|stringformat:"s" == donasi.id|stringformat:"s" %}
            <div style="border: 1px solid #002c3e; padding: 20px; margin-top: 20px;">
                <div>
                    <p>Nama Lengkap : {{i.nama_pendonasi}} </p>
                    <p>Nomor HP / Email : {{i.hp_email}} </p>
                    <p>Nominal Donasi : {{i.nominal_donasi}} </p>
                    <p>Metode Donasi : {{i.metode_donasi}} </p>
                    <p>Pesan : {{i.dukungan}} </p>
                </div>
                <div class="row justify-content-center unggah">
                    <form method ="POST" action="{% url 'user:delete_pendonasian' donasi.id i.id %}">{% csrf_token %}
                        <div class="col-6">
                            <button type="submit" class="btn btn-listadopsi">Tolak</button>
                        </div>     
                    </form>
                    <form method ="POST" action="{% url 'user:berhasil_donasi' donasi.id i.id %}">{% csrf_token %}
                        <div class="col-6">
                            <button type="submit" class="btn btn-listadopsi">Konfimrasi</button>
                        </div>     
                    </form>  
                </div>
            </div>
            {% endif %}
            {% endfor %}
        </div>
	</div>
</div>
<br><br>
{% endblock content_block %}

templates/opendonasi/melakukandonasi.html
{% extends 'navbar.html' %}
{% block content_block %}
<a type="button" onclick="location.href='/user/detail-donasi/{{donasi.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Yuk Donasi!</p><br>
	</div>
</div>

<div class="container">
    <form method="POST" >
        {% csrf_token %}
        <div class="row justify-content-center">
            <div class="col-7">
                <p class="form-label">Masukan Nominal Donasi</p>
                <input type="number" class="form-control" name = "nominal_donasi" placeholder="minimal Rp5000">
                <p class="form-label">Pilih Metode Pembayaran</p>
                <div>
                    <select id="metode" name="metode_donasi" class="form-control">
                    <option value="gopay">GO-PAY</option>
                    <option value="jenius">Jenius</option>
                    <option value="linkaja">LinkAja</option>
                    <option value="ovo">OVO</option>
                    <option value="bca">BCA</option>
                    <option value="bni">BNI</option>
                    <option value="bri">BRI</option>
                    <option value="mandiri">Mandiri</option>
                    <option value="visa">Visa</option>
                    </select>
                </div>  
                <p class="form-label">Nama Lengkap</p>
                <input type="text" class="form-control" name="nama_pendonasi">
                <p class="form-label">Nomor Ponsel atau Email</p>
                <input type="text" class="form-control" name="hp_email">
                <p class="form-label">Sembunyikan nama saya (donasi anonim)</p>
                <label class="switch">
                    <input type="checkbox" name="anonim_donasi" placeholder="anonim_donasi" id="anonim_donasi" aria-label="anonim_donasi">
                    <span class="slider"></span>
                </label>
                <p class="form-label">Tulis doa dan dukungan (opsional)</p>
                <textarea rows="10" cols="30" class="form-control" placeholder="Beri doa, dan dukunganmu disini" name="dukungan" style="resize: none;"></textarea>
            </div>
        </div>
        <div class="row justify-content-center unggah">
            <div class="col-6">
                <button type="submit" class="btn btn-secondary" href='detail-donasi/{{donasi.id}}/list-donasi/'>Donasikan</button>
            </div>        
        </div>
    </form>
    <br><br>

</div>

{% endblock content_block %}